/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _DATAIMAGE_H
#define _DATAIMAGE_H

#include "Reader.h"
#include "Image.h"

class DataImage : public Image
{
 protected:
	Reader *reader; /* file to read from, must be set by subclass */
	int start; /* starting line data is saved from */
	int end; /* ending line data is saved */
	int byte_width; /* width of image in bytes(width/8), must be set by subclass*/
	unsigned char *bytes; /* array of data currently cached */

 public:
	virtual void cacheLines(int start, int len);
	virtual void getRGB(RGB *rgb, int x, int y) = 0;

	DataImage();
	~DataImage();
};


#endif
