/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _LEXMARK_PROTOCOL_300C_H
#define _LEXMARK_PROTOCOL_300C_H

#include "Coord.h"
#include "PaintLine300c.h"
#include "Writer.h"
#include "Map.h"
#include "PrinterProtocol.h"
#include "Rect.h"

class LexmarkProtocol300c : public LexmarkProtocol
{
 private:
	PaintLine300c *paintLine;
	PaintLine300c *lastPaintLine;
	bool firstPaintLine;
	bool pageStarted;
	Writer *writer;

	int y;
	void advancePage(int y,bool last);
	void printPaintLine(PaintLine300c *paint, int nextLineStart);
	void printData(int len, ...);
	void printInt(int i);

 public:
	void startPage();
	void adjustPositions(int *startX, int *startY, int *endX);
	void startPaint(int startX, int startY, int size);
	void endPaint();
	void endPage();
	void paint(int sx,int x, int y, int color);

	int getLeftBorder();
	int getTopBorder();
	int getRightBorder();
	int getBottomBorder();

	class Jet **createJets(int *numJets, Map *imageMap);

	//returns the page size in logical printer pixels
	Rect getPageSize(int pageType);
	
	LexmarkProtocol300c(Writer *writer);
	~LexmarkProtocol300c();
};

#endif

